//
//  SLHomeViewController.m
//  SLAiELTS
//
//  Created by Gusont on 2023/3/8.
//

#import "SLHomeViewController.h"
#import "SLHomeView.h"

@interface SLHomeViewController ()

@property (nonatomic, strong) SLHomeView *homeView;
@end

@implementation SLHomeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    if (@available(iOS 11.0, *)) {
        self.homeView.mainCollectionView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
    } else {
        self.automaticallyAdjustsScrollViewInsets = NO;
    }
    self.homeView.viewModels = [SLPageViewModel homePageViewModels];
    self.navigationBar.hidden = YES;
    [self.homeView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.view);
    }];
    [self.homeView.mainCollectionView reloadData];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear: animated];
    [SLUserModel requestUserRoleModel];
}

- (SLHomeView *)homeView {
    if (!_homeView) {
        _homeView = [[SLHomeView alloc] initWithFrame:CGRectZero];
        [self.view addSubview:_homeView];
    }
    return _homeView;
}

@end
