//
//  SLForgetPWViewController.m
//  SLAiELTS
//
//  Created by Gusont on 2023/2/27.
//

#import "SLForgetPWViewController.h"
#import "SLRetrievePWViewController.h"

#import "SLVerifiButton.h"

@interface SLForgetPWViewController ()

@property (weak, nonatomic) IBOutlet SLVerifiButton *codeBtn;
@property (weak, nonatomic) IBOutlet UITextField *phoneTextField;
@property (weak, nonatomic) IBOutlet UITextField *codeTextField;

@end

@implementation SLForgetPWViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.navigationBar.hidden = YES;
    //  获取到clearbutton 可以获取样式上
    UIButton *btn = [self.phoneTextField valueForKey:@"_clearButton"];
    [btn setImage:ImageName(@"icon_clear_circle") forState:UIControlStateNormal];
}

- (IBAction)backBtnClick:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
}

- (IBAction)retrieveBtnClick:(id)sender {
    if (!self.phoneTextField.text.length) {
        [ZFToast ShowWithMessage:@"请输入手机号"];
        return;
    }
    if (!self.codeTextField.text.length) {
        [ZFToast ShowWithMessage:@"请输入验证码"];
        return;
    }
    SLRetrievePWViewController *vc = [SLRetrievePWViewController loadViewControllewWithNib];
    vc.phoneStr = self.phoneTextField.text;
    vc.codeStr = self.codeTextField.text;
    [self.navigationController pushViewController:vc animated:YES];
}
- (IBAction)codeBtnClick:(id)sender {
    NSString *phoneStr = self.phoneTextField.text;
    if (!phoneStr.length) {
        [ZFToast ShowWithMessage:@"请输入手机号"];
        return;
    }
    [[SLHttpCenter SharedInstance] getWithUrl:@"/api/Token/GetPhoneValidateCode" parameter:@{@"phone" : phoneStr} success:^(id responseObject) {
        SLVerifiButton *btn = (SLVerifiButton *)sender;
        [btn startTiming];
    } failure:^(SPRequestError *error) {
        
    }];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
