//
//  SLFeedbackVc.m
//  SLAiELTS
//
//  Created by Gusont on 2023/3/14.
//

#import "SLFeedbackVc.h"
#import "PlaceholderTextView.h"
#import "SLBaseCellView.h"
#import "SLPickView.h"

@interface SLFeedbackVc ()<UITextViewDelegate>
@property (weak, nonatomic) IBOutlet SLBaseCellView *topView;

@property (weak, nonatomic) IBOutlet PlaceholderTextView *textView;

@property (weak, nonatomic) IBOutlet UILabel *textLabel;
@property (weak, nonatomic) IBOutlet UISwitch *feedBackSwitch;

@property (nonatomic, strong)NSString *classify;
@end

@implementation SLFeedbackVc

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.title = @"意见反馈";
    self.classify = @"";
    self.textView.placeholder = @"想对我们说什么？";
    self.textView.font = [UIFont systemFontOfSize:16];
    self.textView.delegate = self;
    self.topView.titleLabel.text = @"选择问题分类";
    self.topView.titleLabel.textColor = [[UIColor blackColor] colorWithAlphaComponent:0.9];
    self.topView.subTitleLabel.text = @"问题类别";
    [self.topView updateConstraintsWith:SLBaseCellView1];
    self.topView.lineView.hidden = YES;
    WS(weakSelf);
    [self.topView addTapWithBlock:^{
        NSMutableArray *arr = [NSMutableArray array];
        [arr addObject:@[@"程序崩溃",@"其他问题"]];
        SLPickView *pickView = [[SLPickView alloc] initWithPickerData:arr];
        pickView.resultBlock = ^(NSString * _Nullable str, NSArray *titlesValue) {
            weakSelf.classify = str;
            weakSelf.topView.subTitleLabel.text = str;
        };
        [pickView show];
    }];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text {
    NSString *toBeString = [textView.text stringByReplacingCharactersInRange:range withString:text];
    if (toBeString.length > 500) {
        return NO;
    }
    self.textLabel.text = [NSString stringWithFormat:@"%ld/500",toBeString.length];
    return YES;
}

- (IBAction)sureBtnClick:(id)sender {
    if (!self.classify.length) {
        [ZFToast ShowWithMessage:@"请选择问题类别"];
        return;
    }
    if (!self.textView.text.length) {
        [ZFToast ShowWithMessage:@"请输入反馈内容"];
        return;
    }
    if (self.textView.text.length) {
        NSDictionary *dict = @{@"classify" : self.classify, @"content" : self.textView.text, @"isContact" : @(self.feedBackSwitch.isOn)};
        [[SLHttpCenter SharedInstance] postWithUrl:@"/api/User/InsertFeedback" parameter:dict success:^(id responseObject) {
            [ZFToast ShowWithMessage:@"反馈成功"];
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.navigationController popToRootViewControllerAnimated:YES];
            });
        } failure:^(SPRequestError *error) {
            
        }];
    }
}

@end
