

#import "SLMeHeaderCollectionViewCell.h"
#import "SLUserCenterViewController.h"
#import "SLLoginVCViewController.h"

@interface SLMeHeaderCollectionViewCell()

@property (nonatomic, strong) UIImageView *bgImageView;

@property (nonatomic, strong) UIImageView *headView;//头像

@property (nonatomic, strong) UILabel *nameLabel;//名称

@property (nonatomic, strong) UILabel *loginTimeLabel;//登录时间

@property (nonatomic, strong) UIButton *setUpBtn;//设置

@property (nonatomic, strong) UIButton *loginBtn;//登录

@property (nonatomic, strong) UIView *bottomBgView;//

@end

static const NSInteger btnTag = 888888;

@implementation SLMeHeaderCollectionViewCell

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self confignUI];
    }
    return self;
}


- (void)headViewClick
{
   
}

- (void)btnClick:(UIButton *)btn
{
    [self.viewController navPushViewController:[SLLoginVCViewController loadViewControllewWithNib] animated:YES];
}

- (void)setBtnClick:(UIButton *)btn
{
    [self.viewController navPushViewController:[SLUserCenterViewController loadViewControllewWithNib] animated:YES];
}

- (void)drawRect:(CGRect)rect
{
    self.bottomBgView.backgroundColor = [UIColor whiteColor];
}

- (void)confignUI
{
    CGFloat bgHeight = (197 + kStatusBarHeight / 2) * KScaleW;
    CGFloat headOffsetY = -6;
    [self.bgImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.equalTo(self.contentView);
        make.height.equalTo(@(bgHeight));
    }];
    
    [self.headView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(@(20));
        make.centerY.equalTo(self.bgImageView).offset(headOffsetY - 5);
        make.width.height.equalTo(@(52 * KScaleW));
    }];
    //
    [self.nameLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.headView);
        make.left.equalTo(self.headView.mas_right).offset(10 * KScaleW);
    }];
    
    [self.loginTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.nameLabel.mas_bottom).offset(7);
        make.left.equalTo(self.nameLabel.mas_left);
    }];
    

    [self.setUpBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.headView);
        make.right.equalTo(self.bgImageView.mas_right).offset(-20);
    }];
    
    [self.bottomBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.contentView);
        make.bottom.equalTo(self.contentView).offset(-14 * KScaleW);
        make.left.equalTo(self.contentView).offset(20);
        make.height.equalTo(@(96 * KScaleW));
    }];
    
    UIImage *image = [UIImage gradientImageSize:CGSizeMake(kSCREEN_WIDTH, bgHeight) startPoint:CGPointMake(0, 0) endPoint:CGPointMake(0,bgHeight) colors:@[SLColor(@"#B2E8FF"), [SLColor(@"#B2E8FF") colorWithAlphaComponent:0.53],[SLColor(@"#B2E8FF") colorWithAlphaComponent:0.0],]];
    self.bgImageView.image = image;
    
    WS(weakSelf);
    [self.KVOController observe:[SLGlobalInfo SharedInstance] keyPath:@"loginInfo" options:NSKeyValueObservingOptionNew | NSKeyValueObservingOptionOld block:^(id  _Nullable observer, id  _Nonnull object, NSDictionary<NSKeyValueChangeKey,id> * _Nonnull change) {
        SLLoginInfo *targetModel = [SLGlobalInfo SharedInstance].loginInfo;
        if (targetModel) {
            weakSelf.nameLabel.text = [NSString stringWithFormat:@"Hi,%@",targetModel.user.name];
            weakSelf.loginTimeLabel.text = [NSString stringWithFormat:@"账号：%@",targetModel.user.phone];
            NSString *headUrl = [NSString stringWithFormat:@"%@%@",[SLHttpCenter SharedInstance].serverUrl, [SLGlobalInfo SharedInstance].loginInfo.user.head];
            [weakSelf.headView sd_setImageWithURL:[NSURL URLWithString:headUrl] placeholderImage:ImageName(@"icon_ellipse")];
        }else {
            weakSelf.nameLabel.text = @"尊敬的客户，您好！";
            weakSelf.loginTimeLabel.text = @"未登录";
            weakSelf.headView .image = ImageName(@"icon_ellipse");
        }
    }];
}

- (void)confignCellWithModel:(SLPageModel *)pageModel {
    [self.bottomBgView.subviews enumerateObjectsUsingBlock:^(__kindof UIView * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        [obj removeFromSuperview];
        obj = nil;
    }];
    NSMutableArray *marr = [NSMutableArray new];
    [pageModel.modelDetails enumerateObjectsUsingBlock:^(SLPageModelDetail * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [marr addObject:btn];
        [self.bottomBgView addSubview:btn];
        UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectZero];
        [btn addSubview:imageView];
        imageView.userInteractionEnabled = YES;
        imageView.image = ImageName(obj.bgImage);
        [imageView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(btn);
            make.top.equalTo(btn).offset(14 * KScaleW);
        }];
        
        UILabel *label = [[UILabel alloc] initWithFrame:CGRectZero];
        [btn addSubview:label];
        label.textColor = [UIColor colorFormString:@"#080F1B"];
        label.text = obj.title;
        label.font = [UIFont systemFontOfSize:14];
        [label mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(imageView);
            make.top.equalTo(imageView.mas_bottom).offset(4);
        }];
        UIButton *btn2 = [UIButton buttonWithType:UIButtonTypeCustom];
        btn2.backgroundColor = UIColor.clearColor;
        btn2.tag = btnTag + idx;
        [btn2 addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
        [btn addSubview:btn2];
        [btn2 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.edges.equalTo(btn);
        }];
    }];
    [marr mas_distributeViewsAlongAxis:MASAxisTypeHorizontal withFixedSpacing:0 leadSpacing:0 tailSpacing:0];
    [marr mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.bottomBgView);
        make.height.equalTo(self.bottomBgView);
    }];
}

- (UIImageView *)bgImageView
{
    if (!_bgImageView) {
        _bgImageView = [[UIImageView alloc] initWithFrame:CGRectZero];
        _bgImageView.image = [UIImage imageNamed:@"icon_me_bg"];
        _bgImageView.userInteractionEnabled = YES;
        [self.contentView addSubview:_bgImageView];
    }
    return _bgImageView;
}

- (UIImageView *)headView
{
    if (!_headView) {
        _headView = [[UIImageView alloc] initWithFrame:CGRectZero];
        _headView.image = [UIImage imageNamed:@"icon_ellipse"];
        _headView.userInteractionEnabled = YES;
        CGFloat radius = 26;
        _headView.layer.cornerRadius = radius * KScaleW;
        _headView.clipsToBounds = YES;
        UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(headViewClick)];
        [_headView addGestureRecognizer:tap];
        [self.bgImageView addSubview:_headView];
    }
    return _headView;
}

- (UILabel *)loginTimeLabel
{
    if (!_loginTimeLabel) {
        _loginTimeLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _loginTimeLabel.font = [UIFont systemFontOfSize:16];
        _loginTimeLabel.textColor = SLColor(@"#8E8E93");
        _loginTimeLabel.text = @"未登录";
        [self.bgImageView addSubview:_loginTimeLabel];
    }
    return _loginTimeLabel;
}

- (UILabel *)nameLabel
{
    if (!_nameLabel) {
        _nameLabel = [[UILabel alloc] initWithFrame:CGRectZero];
        _nameLabel.font = [UIFont boldSystemFontOfSize:20];
        _nameLabel.textColor = SLColor(@"#080F1B");
        _nameLabel.text = @"尊敬的客户，您好！";
        [self.bgImageView addSubview:_nameLabel];
    }
    return _nameLabel;
}

- (UIButton *)setUpBtn
{
    if (!_setUpBtn) {
        _setUpBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_setUpBtn addTarget:self action:@selector(setBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        _setUpBtn.titleLabel.font = [UIFont systemFontOfSize:14];
        _setUpBtn.backgroundColor = UIColor.clearColor;
        _setUpBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
        [_setUpBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_setUpBtn setImage:[UIImage imageNamed:@"icon_my_set"] forState:UIControlStateNormal];
        [self.bgImageView addSubview:_setUpBtn];
    }
    return _setUpBtn;
}

- (UIView *)bottomBgView
{
    if (!_bottomBgView) {
        _bottomBgView = [[UIView alloc] initWithFrame:CGRectZero];
        _bottomBgView.layer.cornerRadius = 20.f;
        [self.contentView addSubview:_bottomBgView];
    }
    return _bottomBgView;
}

@end
