//
//  SLRoleLabelView.m
//  SLAiELTS
//
//  Created by Gusont on 2023/2/28.
//

#import "SLRoleLabelView.h"
#import "SLCustomSegment.h"
#import "SLNuisdkPlay.h"
#import "SLRoleappearanceView.h"

@interface SLRoleLabelView ()<YMCustomSegmentDelegate>

@property (nonatomic, assign) SLRoleModelType roleLabelType;

@property (nonatomic, strong) RoleModel *roleModel;

@property (nonatomic, strong) SLNuisdkPlay *play;

@end

@implementation SLRoleLabelView

- (instancetype)initWithCoder:(NSCoder *)aDecoder {
    self = [super initWithCoder:aDecoder];
    if (self) {
        [self addContentView];
    }
    return self;
}
- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self addContentView];
    }
    return self;
}

- (void)addContentView {
    [[NSBundle mainBundle] loadNibNamed:@"SLRoleLabelView" owner:self options:nil];
    self.contentView.frame = self.bounds;
    [self addSubview:self.contentView];
    self.contentView.backgroundColor = UIColor.clearColor;
}

- (void)confignWithRoleType:(SLRoleModelType)roleType :(RoleModel *)roleModel {
    NSArray *arr = @[];
    NSString *titleStr = @"";
    self.roleLabelType = roleType;
    self.roleModel = roleModel;
    switch (roleType) {
        case SLRoleSex:
        {
            arr = @[@[@"男性",@"女性"]];
            titleStr = @"选择你的助教老师的性别";
        }
            break;
        case SLRoleappearance:
        {
            arr = @[@[@"头发",@"皮肤", @"眼睛"]];
            titleStr = @"选择你的助教老师的形象造型";
            SLRoleappearanceView *appearanceView = [self creatRoleappearanceView];
            [appearanceView mas_makeConstraints:^(MASConstraintMaker *make) {
                make.centerX.equalTo(self);
                make.left.mas_equalTo(20);
                make.height.mas_equalTo(140);
                make.bottom.equalTo(self.mas_bottom).offset(-76);
            }];
        }
            break;
        case SLRoleLanguage:
        {
            arr = @[@[@"英音",@"美音"], @[@"快", @"中", @"慢"]];
            titleStr = @"  ";
            [self confignWithRoleLanguage];
        }
            break;
        case SLRoleName:
        {
            arr = @[];
            [self.subviews enumerateObjectsUsingBlock:^(__kindof UIView * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
                if ([obj isKindOfClass:SLCustomSegment.class]) {
                    [obj removeFromSuperview];
                    obj = nil;
                }
            }];
            titleStr = @"快来给我取名字吧！";
        }
            break;
        default:
            break;
    }
    self.titleLabel.text = titleStr;
    if (arr.count) {
        [arr enumerateObjectsUsingBlock:^(NSArray *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
            SLCustomSegment *segmentView = [self creatSegmentView];
            CGFloat h = (arr.count - idx - 1) * 60;
            if (roleType == SLRoleLanguage) {
                h += 60;
            }
            [segmentView mas_makeConstraints:^(MASConstraintMaker *make) {
                make.centerX.equalTo(self);
                make.left.mas_equalTo(20);
                make.height.mas_equalTo(52);
                make.bottom.equalTo(self.mas_bottom).offset(-(12 + h));
            }];
            [segmentView setTitlesWithArray:obj];
            if (roleType == SLRoleLanguage && idx == 1) {
                segmentView.selectIndex = 1;
            }else {
                segmentView.selectIndex = 0;
            }
        }];
    }
}

- (void)confignWithRoleLanguage {
    UIButton *cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    cancelBtn.backgroundColor = [UIColor colorWithRed:199 / 255.0 green:235 / 255.0 blue:253 / 255.0 alpha:1];
    [cancelBtn setTitle:@"试听语音" forState:UIControlStateNormal];
    cancelBtn.layer.borderColor = [SLBlueColor CGColor];
    cancelBtn.layer.borderWidth = 1.0f;
    cancelBtn.layer.cornerRadius = 24.0f;
    [cancelBtn addTarget:self action:@selector(payBtnClick) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:cancelBtn];
    [cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self);
        make.left.mas_equalTo(22);
        make.height.mas_equalTo(48);
        make.bottom.mas_equalTo(self.mas_bottom).offset(-12);
    }];
}

- (void)payBtnClick {
    [self.play startTTSWith:SLDefaultPlay roleModel:self.roleModel finshBlock:^{
        
    }];
}

- (void)customSegmentSelectIndex:(NSInteger)selectIndex title:(nonnull NSString *)title {
    //最好构造模型
    NSDictionary *dict = [RoleModel roleModelDict];
    NSString *value = [dict objectForKey:title];
    switch (self.roleLabelType) {
        case SLRoleSex:
        {
            self.roleModel.dataSex = value;
        }
            break;
        case SLRoleappearance:
        {
            SLRoleappearanceView *view = (SLRoleappearanceView *)[self viewWithTag:222233];
            
            switch (selectIndex) {
                case 0:
                {
                    [view confignWith:selectIndex colors:@[SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor]];
                }
                    break;
                case 1:
                {
                    [view confignWith:selectIndex colors:@[UIColor.redColor,UIColor.redColor,UIColor.redColor,SLBgColor,UIColor.redColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,UIColor.redColor,UIColor.redColor]];
                }
                    break;
                case 2:
                {
                    [view confignWith:selectIndex colors:@[UIColor.blueColor,UIColor.blueColor,SLBgColor,SLBgColor,UIColor.blueColor,SLBgColor,SLBgColor,SLBgColor,SLBgColor,UIColor.blueColor,SLBgColor,UIColor.blueColor,UIColor.blueColor,SLBgColor]];
                }
                    break;
                    
                default:
                    break;
            }
        }
            break;
        case SLRoleLanguage:
        {
            if ([title containsString:@"音"]) {
                self.roleModel.language = value;
            }else {
                self.roleModel.speechRate = value;
            }
        }
            break;
        case SLRoleName:
        {
            
        }
            break;
        default:
            break;
    }
}

- (SLCustomSegment *)creatSegmentView
{
    CGFloat sHeight = 52;
    SLCustomSegment *segment = [[SLCustomSegment alloc] initWithFrame:CGRectMake(0, 0, kSCREEN_WIDTH - 40, sHeight) titleArray:@[@"男",@"女"]];
    segment.normalTitleFont = 14;
    segment.selectTitleFont = 14;
    segment.cornerRadius = 26.0f;
    segment.backgroundColor = [SLBlackColor colorWithAlphaComponent:0.3];
    segment.tag = 110022;
    segment.delegate = self;
    segment.normalBackgroundColor = [UIColor clearColor];
    segment.selectBackgroundColor = [UIColor whiteColor];
    segment.titleNormalColor = [UIColor whiteColor];
    segment.titleSelectColor = SLBlackColor;
    [self addSubview:segment];
    return segment;
}

- (SLRoleappearanceView *)creatRoleappearanceView {
    SLRoleappearanceView *view = [[SLRoleappearanceView alloc] initWithFrame:CGRectZero];
    view.backgroundColor = [SLBlackColor colorWithAlphaComponent:0.3];
    view.clipsToBounds = YES;
    view.layer.cornerRadius = 20.0f;
    view.tag = 222233;
    [self addSubview:view];
    view.selBlock = ^(NSInteger selIdx, UIColor *color) {
        switch (selIdx) {
            case 0:
            {
                
            }
                break;
            case 2:
            {
                
            }
                break;
            case 3:
            {
                
            }
                break;
                
            default:
                break;
        }
    };
    return view;
}

- (SLNuisdkPlay *)play {
    if (!_play) {
        _play = [[SLNuisdkPlay alloc] init];
    }
    return _play;
}

@end
